﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
        public delegate bool EnumWindowProc(IntPtr hWnd, IntPtr parameter);
        #region import
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        static extern bool EnumChildWindows(IntPtr hwndParent, EnumWindowProc lpEnumFunc, IntPtr lParam);

        [DllImport("user32.dll", SetLastError = false)]
        static extern IntPtr GetDesktopWindow();

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        static extern int GetWindowText(IntPtr hWnd, StringBuilder lpString, int nMaxCount);

        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        static extern int GetWindowTextLength(IntPtr hWnd);

        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        static extern int GetClassName(IntPtr hWnd, StringBuilder lpClassName, int nMaxCount);

        [DllImport("user32.dll", SetLastError = true)]
        static extern uint GetWindowThreadProcessId(IntPtr hWnd, out int lpdwProcessId);

        [DllImport("user32.dll", SetLastError = true)]
        public static extern IntPtr FindWindow(string lpClassName, string lpWindowName);
        #endregion

        public Form1()
        {
            InitializeComponent();
        }

        public static List<IntPtr> GetChildWindows(IntPtr parent)
        {
            List<IntPtr> result = new List<IntPtr>();
            GCHandle listHandle = GCHandle.Alloc(result);
            try
            {
                EnumWindowProc childProc = new EnumWindowProc(EnumWindow);
                EnumChildWindows(parent, childProc, GCHandle.ToIntPtr(listHandle));
            }
            finally
            {
                if (listHandle.IsAllocated)
                    listHandle.Free();
            }
            return result;
        }

        private static bool EnumWindow(IntPtr handle, IntPtr pointer)
        {
            GCHandle gch = GCHandle.FromIntPtr(pointer);
            List<IntPtr> list = gch.Target as List<IntPtr>;
            if (list == null)
            {
                throw new InvalidCastException("GCHandle Target could not be cast as List<IntPtr>");
            }
            list.Add(handle);
            //  You can modify this to check to see if you want to cancel the operation, then return a null here
            return true;
        }

        public static string GetText(IntPtr hWnd)
        {
            // Allocate correct string length first
            int length = GetWindowTextLength(hWnd);
            StringBuilder sb = new StringBuilder(length + 1);
            GetWindowText(hWnd, sb, sb.Capacity);
            return sb.ToString();
        }

        public static string GetClassName(IntPtr hWnd)
        {
            StringBuilder className = new StringBuilder(100);
            //Get the window class name
            GetClassName(hWnd, className, className.Capacity);

            return className.ToString();
        }

        public static Process GetProcess(IntPtr hWnd)
        {
            int processId = 0;
            GetWindowThreadProcessId(hWnd, out processId);
            return Process.GetProcessById(processId);
        }
        
        private void Timer()
        {
            DateTime plop = DateTime.Now;
            List<IntPtr> wndList = GetChildWindows(GetDesktopWindow());
            //IntPtr hWnd = FindWindow(null, "Track Information - RailScan");
            //List<IntPtr> wndList = GetChildWindows(hWnd);
            string sPattern = "^: \\d{2}:\\d{2}:\\d{2},\\d{6}";

            foreach (IntPtr item in wndList)
            {
                string s = GetText(item);
                if (System.Text.RegularExpressions.Regex.IsMatch(s, sPattern))
                {
                    //label1.Text = "hWnd: " + item.ToString() + "\t\tText: " + s + "\tTime : " + (DateTime.Now - plop).ToString();
                    label1.Text = "\t\tTime: " + s;
                    this.Refresh();
                    break;
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            Timer();
        }
    }
}
